<template>
  <div class="app">
    <vue-headful
            title="HackaMarket | Clientes"
             description="Sección con todos los clientes de HackaMarket"

        />
    <section>

        <h1>Clientes</h1>
        <h2>de Hack&Market</h2>
      <div>
        <!-- mostramos los clientes -->
        <!-- borrar viene del $emit de ProductosCustom y borrandoCliente del méthod de abajo -->
        <listaclientes v-on:borrar="borrandoCliente" v-on:datos="mostrarInfoCliente"  :clientes="clientes" /> 
  
      </div>
    </section>

  
 <!-- INICIO MODAL ACTUALIZAR CLIENTE -->
  <br>
    <div v-show="seeModal"  class="modal" >
      <div class="modalBox">
          <h3 class="titlemodal">Actualiza los datos de tu cliente</h3>

          <input type="text" placeholder="nombre del cliente" v-model="nombreActualizado">
          <input type="text" placeholder="Usuario" v-model="usuarioActualizado">
          <input type="text" placeholder="password" v-model="passwordActualizado">
          <input type="text" placeholder="email" v-model="emailActualizado">
          <input type="text" placeholder="foto" v-model="fotoActualizada">
          <br>
          <button @click="seeModal =! seeModal" class="button">Cancelar</button>
          <button @click="editarCliente()">Actualizar datos</button>
      </div>
    </div>
  <!-- FIN MODAL ACTUALIZAR CLIENTE -->
  
  </div>
</template>

<script>
import axios from 'axios';  // importamos axios
import listaclientes from '@/components/ClientesCustom.vue';
import Swal from 'sweetalert2';

export default {
  name: 'Clientes',
  components: {
    listaclientes
  },
//FIN COMPONENTS
//INICIO DATA
  data(){
    return{
      clientes:[], // aquí guardamos los productos que vengan de la BBDD

      idCliente:'',
      nombreActualizado:'',
      usuarioActualizado:'',
      passwordActualizado:'',
      emailActualizado:'',
      fotoActualizada:'',

      seeModal: false // ocultar el modal 

    }
  },
//FIN DATA
//INICIO METHODS
  methods:{
    editarCliente(){
      var self = this;
      axios.put('http://localhost:3050/update/' + self.idCliente, {
        nombre: self.nombreActualizado,
        usuario: self.usuarioActualizado,
        password: self.passwordActualizado,
        email: self.emailActualizado,
        foto: self.fotoActualizada
      })
      .then(function(response) {
        console.log(response)
      })
      .catch(function(error){
        console.log(error)
      })
      
       Swal.fire({title:'El cliente ha sido actualizado correctamente',
       onClose:()=>{
         location.reload()}
         })
    },

    // MODAL datosCliente viene del componente
    // cogemos la info y la igualamos a las variables de data para actualizar la info
    mostrarInfoCliente(datosCliente){
        this.nombreActualizado = datosCliente.nombre
        this.usuarioActualizado = datosCliente.usuario
        this.passwordActualizado = datosCliente.password
        this.emailActualizado = datosCliente.email
        this.fotoActualizada = datosCliente.foto

        this.idCliente = datosCliente.id

        // mostramos el modal
        this.seeModal = true
    },







   //INICIO BORRAR CLIENTE 
    borrandoCliente(indiceCliente){
      var self = this;
      // añadimos el id de cliente al final de la url
      axios.delete('http://localhost:3050/delete/' + indiceCliente )
        .then(function(response){
          console.log(response)
        })
        .catch(function(error){
          console.log(error)
        })
        // Al cerrar el modal de sweetalert2 se actualiza la página
       Swal.fire({title:'Cliente eliminado correctamente',
       onClose:()=>{
         location.reload()}}
       )
    },
    // FIN BORRAR CLIENTE
    // FUNCIÓN PARA CONSEGUIR MIS CLIENTES
    getClientes(){
      var self = this;
      // LLAMADA DE AXIOS A LA API
      axios.get('http://localhost:3050/clientes')
      .then( function(response) {
        //Guardamos la respuesta de la API en el array clientes
        self.clientes = response.data
      })
      .catch( function (error) {
        console.log(error)
      })
    }
    // FIN CONSEGUIR LISTA PRODUCTOS
  },
  created() {
    this.getClientes()
  }
//FIN METHODS
}

</script>
<style scoped>
* {
  padding: 0;
  margin: 0;
  box-sizing: border-box;
}
/* .container {
  margin-top: var(--spacer50px);
  display: flex;
  width: 100%;
  height: var(--size100vh);;
  padding: 0.5rem;
} */
.titlemodal {
   margin-bottom: var(--spacer25px)
  }
.modal{
  position: fixed;
  top:0;
  left: 0;
  right: 0;
  bottom: 0;
  background: rgba(0, 0, 0, 0.5);
}

.modalBox {
  background-color: whitesmoke ;
  margin: 2% auto;
  padding: 3rem;
  width: 400px;
  border: 4px solid black;
  border-radius: 3px;

}

 input{
        padding:8px;
        border:none;
        border-bottom:3px solid #263238;
        width:300px;
        background-color: var(--bg-whitesmoke);
        margin-bottom: 25px;
    }
  button {
        background-color: orangered; 
        border: none;
        color: white;
        padding: 15px 20px;
        text-align: center;
        text-decoration: none;
        font-size: var(--size16px);
        margin: 10px 2px;
        cursor: pointer;
    }
.app {
  background-color:var(--bg-whitesmoke);
  display: flex;
  flex-direction: column;
  /* min-height: calc( var(--size100vh) - 100px); */
}
 h1 {
   padding-top: var(--spacer100px);
   margin-bottom: -20px;
   font-size: var(--size100px)
  }
h2 {
    margin-top: 0px;
  }
   @media only screen and (max-width: 425px){
        
      h1 {
        padding-top: var(--spacer200px);
      }
    }

</style>
